<p align=center>
<img src="https://raw.github.com/nasa/Trick/master/TrickLogo.png" alt="Trick Logo" height=150px>
</p>

<p align=justify>
The Trick Simulation Environment, developed at the NASA Johnson Space Center, is a powerful simulation development framework that enables users to build applications for all phases of space vehicle development. Trick expedites the creation of simulations for early vehicle design, performance evaluation, flight software development, flight vehicle dynamic load analysis, and virtual/hardware in the loop training. Trick's purpose is to provide a common set of simulation capabilities that allow users to concentrate on their domain specific models, rather than simulation-specific functions like job ordering, input file processing, or data recording.
</p>

<table>
    <col width="33%">
    <col width="33%">
    <col width="33%">
    <thead>
        <tr>
            <th><a href="https://github.com/nasa/trick/wiki/Install-Guide">Install Guide</a></th>
            <th><a href="https://github.com/nasa/trick/wiki/Tutorial">Tutorial</a></th>
            <th><a href="https://github.com/nasa/trick/wiki/Documentation-Home">Documentation</a></th>
        </tr>
    </thead>
    <tbody>
        <tr align="center">
            <td>Follow the installation guide to properly configure Trick on your operating system.</td>
            <td>Complete the tutorial to become familiar with the basics.</td>
            <td>Visit the documentation for a more complete understanding of Trick.</td>
        </tr>
    </tbody>
</table>

<table>
    <col width="33%">
    <col width="33%">
    <col width="33%">
    <thead>
        <tr>
            <th><a href="https://github.com/nasa/trick/wiki/Related-Projects">Related Projects</a></th>
            <th><a href="https://github.com/nasa/trick/wiki/FAQ">Frequently Asked Questions</a></th>
            <th><a href="https://github.com/nasa/trick/wiki/How-To-Home">How-To Guides</a></th>
        </tr>
    </thead>
    <tbody>
        <tr align="center">
            <td>View some of the many projects that use Trick.</td>
            <td>Read some of the most frequently asked questions pertaining to Trick.</td>
            <td>See a collection of how-to guides detailing common Trick processes.</td>
        </tr>
    </tbody>
</table>

---

Trick is released under the NASA Open Source Agreement Version 1.3 [license](https://github.com/nasa/trick/blob/master/LICENSE).
